Package com.emc.documentum.rest.model

# Class TypeObject

java.lang.Object
com.emc.documentum.rest.model.AbstractLinkable
com.emc.documentum.rest.model.PersistentObject
com.emc.documentum.rest.model.TypeObject

All Implemented Interfaces:
  `com.emc.documentum.rest.conditional.Digestible`, `Linkable`

Direct Known Subclasses:
  `TypeLifecycleInfo`

public class TypeObject extends PersistentObject
Type resource

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `ASPECT_PROPERTY`
  `static final int`
  `DATA_TABLE`
  `static final List<String>`
  `DEFAULT_FIELDS`
  Default fields that will be retrieved when use select * in DQL
  `static final int`
  `LIGHTWEIGHT`
  `static final List<String>`
  `MANDATORY_FIELDS`
  Mandatory fields
  `static final int`
  `SHAREABLE`
  `static final int`
  `STANDARD`

  ### Fields inherited from class com.emc.documentum.rest.model.PersistentObject

  `id, isLightweight, isMaterialized, isSnapshot, isVirtual, mandatoryAttributes, optionalAttributes, parentId, permissions, properties, reqDigest, type, typeDef, versionPolicy`

  ### Fields inherited from class com.emc.documentum.rest.model.AbstractLinkable

  `links`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TypeObject()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addAttributeInfo(AttributeInfo attr)`
  Add attribute info
  `void`
  `addConstraint(ValueConstraint constraint)`
  `void`
  `addMappingTable(String value, String display, String desc)`
  `void`
  `addScopeConfig(ScopeConfig scopeConfig)`
  `Map<String,AttributeInfo>`
  `getAttributeInfoAsMap()`
  `List<AttributeInfo>`
  `getAttributeInfoList()`
  Getter for attribute info list
  `List<String>`
  `getAuditableAppEvents()`
  `List<String>`
  `getAuditableSystemEvents()`
  `String`
  `getCategory()`
  Get type category in string
  `String`
  `getCommentText()`
  `List<ValueConstraint>`
  `getConstraints()`
  `Map<String,TypeLifecycleInfo>`
  `getCreateTypeLifecycle(String lifecycle)`
  `TypeLifecycleInfo`
  `getCreateTypeLifecycle(String lifecycle, String state)`
  `String`
  `getDefaultLifecycle()`
  `String`
  `getDefaultLifecycleVersion()`
  `String`
  `getHelpText()`
  `Boolean`
  `getIgnoreConstraints()`
  `String`
  `getLabel()`
  Getter for type label
  `List<String>`
  `getMandatoryFields()`
  Get mandatory attribute names
  `List<MappingTable>`
  `getMappingTables()`
  `String`
  `getName()`
  Getter for type name
  `String`
  `getParent()`
  Getter for type parent
  `List<ScopeConfig>`
  `getScopeConfigs()`
  `String`
  `getSharedParent()`
  Getter for shared parent type
  `String`
  `getType()`
  Get object type of the persistent object; if it is not specified explicitly, return the attribute "r_object_type" by alternate.
  `Map<String,Map<String,TypeLifecycleInfo>>`
  `getTypeLifecycles()`
  `TypeObject`
  `removeDuplicateLifecycleInfo()`
  `void`
  `setAttributeInfoList(List<AttributeInfo> attributeInfoList)`
  `void`
  `setAuditableAppEvents(List<String> auditableAppEvents)`
  `void`
  `setAuditableSystemEvents(List<String> auditableSystemEvents)`
  `void`
  `setCategory(int category)`
  Set type category
  `void`
  `setCategory(String category)`
  Set type category
  `void`
  `setCommentText(String commentText)`
  `void`
  `setConstraints(List<ValueConstraint> constraints)`
  `void`
  `setDefaultLifecycle(String defaultLifecycle)`
  set the default lifecycle id
  `void`
  `setDefaultLifecycleVersion(String defaultLifecycleVersion)`
  set the default lifecycle version
  `void`
  `setHelpText(String helpText)`
  `void`
  `setIgnoreConstraints(Boolean ignoreConstraints)`
  `void`
  `setLabel(String label)`
  Setter for type label
  `void`
  `setMappingTables(List<MappingTable> mappingTables)`
  `void`
  `setName(String name)`
  Setter for type name
  `void`
  `setParent(String parent)`
  Setter for type parent
  `void`
  `setScopeConfigs(List<ScopeConfig> scopeConfigs)`
  `void`
  `setSharedParent(String sharedParent)`
  Setter for shared parent type
  `void`
  `setTypeLifecycles(Map<String,Map<String,TypeLifecycleInfo>> typeLifecycles)`

  ### Methods inherited from class com.emc.documentum.rest.model.PersistentObject

  `addAttribute, addMandatoryAttribute, addOptionalAttribute, calculatesDigest, convertDate, geOptionalAttribute, getAttributeByName, getAttributes, getId, getInternalFields, getMandatoryAttribute, getOptionalFields, getParentId, getPermissions, getReqDigest, getTypeDef, getVersionPolicy, hasAttribute, hasAttributeValue, hasOptionalAttribute, isLightweight, isMatchedWithReqDigest, isMaterialized, isSnapshot, isVirtualDocument, reInitAttributes, removeAttributeIfExisted, setId, setIsSnapshot, setIsVirtualDocument, setLightweight, setMaterialized, setParentId, setPermissions, setReqDigest, setType, setTypeDef, setVersionPolicy, toString`

  ### Methods inherited from class com.emc.documentum.rest.model.AbstractLinkable

  `getLinks, setLinks`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### DEFAULT_FIELDS

    public static final List<String> DEFAULT_FIELDS
    Default fields that will be retrieved when use select * in DQL

  - ### MANDATORY_FIELDS

    public static final List<String> MANDATORY_FIELDS
    Mandatory fields

  - ### STANDARD

    public static final int STANDARD
    See Also:
      - Constant Field Values

  - ### ASPECT_PROPERTY

    public static final int ASPECT_PROPERTY
    See Also:
      - Constant Field Values

  - ### SHAREABLE

    public static final int SHAREABLE
    See Also:
      - Constant Field Values

  - ### LIGHTWEIGHT

    public static final int LIGHTWEIGHT
    See Also:
      - Constant Field Values

  - ### DATA_TABLE

    public static final int DATA_TABLE
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### TypeObject

    public TypeObject()

- ## Method Details

  - ### getType

    public String getType()
    Description copied from class: `PersistentObject`
    Get object type of the persistent object; if it is not specified explicitly, return the attribute "r_object_type" by alternate.
    Overrides:
      `getType` in class `PersistentObject`
    Returns:
      type

  - ### getMandatoryFields

    public List<String> getMandatoryFields()
    Description copied from class: `PersistentObject`
    Get mandatory attribute names
    Overrides:
      `getMandatoryFields` in class `PersistentObject`
    Returns:
      mandatory fields

  - ### getAttributeInfoList

    public List<AttributeInfo> getAttributeInfoList()
    Getter for attribute info list
    Returns:
      attribute info list

  - ### addAttributeInfo

    public void addAttributeInfo(AttributeInfo attr)
    Add attribute info
    Parameters:
      `attr` - attribute info to add

  - ### setAttributeInfoList

    public void setAttributeInfoList(List<AttributeInfo> attributeInfoList)

  - ### getAttributeInfoAsMap

    public Map<String,AttributeInfo> getAttributeInfoAsMap()

  - ### getName

    public String getName()
    Getter for type name
    Returns:
      type name

  - ### getLabel

    public String getLabel()
    Getter for type label
    Returns:
      type label

  - ### getParent

    public String getParent()
    Getter for type parent
    Returns:
      type parent

  - ### setName

    public void setName(String name)
    Setter for type name
    Parameters:
      `name` - type name

  - ### getSharedParent

    public String getSharedParent()
    Getter for shared parent type
    Returns:
      sharedParent shared parent type name

  - ### setSharedParent

    public void setSharedParent(String sharedParent)
    Setter for shared parent type
    Parameters:
      `sharedParent` - the shared parent type name

  - ### setLabel

    public void setLabel(String label)
    Setter for type label
    Parameters:
      `label` - type label

  - ### setParent

    public void setParent(String parent)
    Setter for type parent
    Parameters:
      `parent` - type parent

  - ### getCategory

    public String getCategory()
    Get type category in string
    Returns:
      the type category

  - ### setCategory

    public void setCategory(String category)
    Set type category
    Parameters:
      `category` - the type category in string

  - ### getDefaultLifecycle

    public String getDefaultLifecycle()
    Returns:
      the default lifecycle id

  - ### setDefaultLifecycle

    public void setDefaultLifecycle(String defaultLifecycle)
    set the default lifecycle id
    Parameters:
      `defaultLifecycle` - the default lifecycle id

  - ### getDefaultLifecycleVersion

    public String getDefaultLifecycleVersion()
    Returns:
      the default lifecycle version

  - ### setDefaultLifecycleVersion

    public void setDefaultLifecycleVersion(String defaultLifecycleVersion)
    set the default lifecycle version
    Parameters:
      `defaultLifecycleVersion` - the default lifecycle version

  - ### getAuditableSystemEvents

    public List<String> getAuditableSystemEvents()

  - ### setAuditableSystemEvents

    public void setAuditableSystemEvents(List<String> auditableSystemEvents)

  - ### getAuditableAppEvents

    public List<String> getAuditableAppEvents()

  - ### setAuditableAppEvents

    public void setAuditableAppEvents(List<String> auditableAppEvents)

  - ### getScopeConfigs

    public List<ScopeConfig> getScopeConfigs()

  - ### setScopeConfigs

    public void setScopeConfigs(List<ScopeConfig> scopeConfigs)

  - ### addScopeConfig

    public void addScopeConfig(ScopeConfig scopeConfig)

  - ### getMappingTables

    public List<MappingTable> getMappingTables()

  - ### setMappingTables

    public void setMappingTables(List<MappingTable> mappingTables)

  - ### addMappingTable

    public void addMappingTable(String value, String display, String desc)

  - ### getIgnoreConstraints

    public Boolean getIgnoreConstraints()

  - ### setIgnoreConstraints

    public void setIgnoreConstraints(Boolean ignoreConstraints)

  - ### getConstraints

    public List<ValueConstraint> getConstraints()

  - ### setConstraints

    public void setConstraints(List<ValueConstraint> constraints)

  - ### addConstraint

    public void addConstraint(ValueConstraint constraint)

  - ### getTypeLifecycles

    public Map<String,Map<String,TypeLifecycleInfo>> getTypeLifecycles()

  - ### setTypeLifecycles

    public void setTypeLifecycles(Map<String,Map<String,TypeLifecycleInfo>> typeLifecycles)

  - ### getCreateTypeLifecycle

    public Map<String,TypeLifecycleInfo> getCreateTypeLifecycle(String lifecycle)

  - ### getCreateTypeLifecycle

    public TypeLifecycleInfo getCreateTypeLifecycle(String lifecycle, String state)

  - ### getHelpText

    public String getHelpText()

  - ### setHelpText

    public void setHelpText(String helpText)

  - ### getCommentText

    public String getCommentText()

  - ### setCommentText

    public void setCommentText(String commentText)

  - ### setCategory

    public void setCategory(int category)
    Set type category
    Parameters:
      `category` - the type category in integer

  - ### removeDuplicateLifecycleInfo

    public TypeObject removeDuplicateLifecycleInfo()